
my($default_status) = "unread";
use IO::File;

sub gna_frontdesk_add_to_list {
    my($filename, $item, $status) = @_;
    my($backup) = $filename . ".lck";
    my($file_exists) = (-e $filename);
    local($_);
    if ($status eq undef) {
	$status = $default_status;
    }
    my($counter) = 0;

# Use the backup file as a lock file.  
# This section is a mess and will break with any serious use.
    while (-e $backup && $counter < 20) {
	sleep(1);
	$counter++;
    }

    if ($file_exists) {
	`cp -f $filename $backup`;
    }
    my($output) = IO::File->new(">$filename");

    my ($found_item) = 0;

    if ($file_exists) {
	my($input) = IO::File->new("<$backup");
	my($line);
	while ($line = <$input>) {
	    chop $line;
	    my($old_item, $old_status) = split(/\t/, $line);
	    
	    if ($old_item eq $item) {
		$found_item = 1;
		print $output "$item\t$status\n";
	    } else {
		print $output "$old_item\t$old_status\n";
	    }
	}
	$input->close();
    } 

    if ($found_item == 0) {
	print $output "$item\t$status\n";
    }
    $output->close();

    &gna_frontdesk_permissions_filename($filename);

    `mv $backup ${filename}.bak`;
    &gna_frontdesk_permissions_filename(${filename}. ".bak");
}

sub gna_frontdesk_remove_from_list {
    my($filename, $item) = @_;
    local($_);
    `mv -f $filename $filename.bak`;
    open (OLDLISTFILE, "$filename.bak");
    open (LISTFILE, ">$filename");
    while(<OLDLISTFILE>) {
	chop;
	($old_item) = split(/\t/);
	($old_item ne $item) &&
	    print LISTFILE "$_\n";
    }
    close(LISTFILE);
    close(OLDLISTFILE);
    &gna_frontdesk_permissions_filename($filename); 
}

sub gna_frontdesk_load_list {
    local($filename, *array) = @_;
    open (LISTFILE, "$filename");
    while (<LISTFILE>) {
	chop;
	my($item, $status) = split(/\t/);
	$array{$item} = $status;
    }
    close(LISTFILE);
}
1;
